#!/bin/sh
#
# Start or stop fw_tap
#
# $Id: fw_tap.sh,v 1.2 2002/03/31 16:25:17 simokawa Exp $

#
# Config section
#

# firewire device
dev_fw=/dev/fw2
# channel
CH=1
# tap device
tap=tap0
dev_tap=/dev/$tap

# Bridging
bridged=YES
bridge_interface=fxp0
IF_CONFIG="ifconfig $tap up"
IF_CONFIG2=""
IF_CONFIG_DOWN=""

# No bridging, DHCP
#bridged=NO
#ethernet_addr=00:bd:00:00:00:01
#IF_CONFIG="ifconfig $tap ether $ethernet_addr"
#IF_CONFIG2="/sbin/dhclient $tap"
#IF_CONFIG_DOWN="killall dhclient"

# No bridging, ifconfig
#host_ip="192.168.255.1"
#netmask="0xffffff00"
#IF_CONFIG="ifconfig $tap $host_ip netmask $netmask"
#IF_CONFIG2=""
#IF_CONFIG_DOWN="ifconfig $tap delete $host_ip"

#exec >/dev/null

#
# Main
#
case $1 in
start)
	kldstat -v | grep firewire >/dev/null || kldload firewire.ko
	kldstat -v | grep if_tap >/dev/null || kldload if_tap.ko
	kldstat -v | grep netgraph >/dev/null || kldload netgraph.ko
	kldstat -v | grep ng_ether >/dev/null || kldload ng_ether.ko
	if [ ! -e $dev_tap ]; then
		echo "$dev_tap does not exist!" >&2
		exit 255
	fi
	echo -n > $dev_tap
	ngctl msg $tap: setpromisc 1
	/usr/sbin/fw_tap -f $dev_fw -t $dev_tap $CH &
	$IF_CONFIG
	$IF_CONFIG2
	if [ X$bridged = XYES ]; then
		kldstat -v | grep ng_bridge >/dev/null || kldload ng_bridge.ko
		ngctl mkpeer $tap: bridge lower link0
		ngctl name $tap:lower bridge_$tap
		ngctl connect bridge_$tap: ${bridge_interface}: link1 lower
		ngctl connect bridge_$tap: ${bridge_interface}: link2 upper
		ngctl msg ${bridge_interface}: setautosrc 0
		ngctl msg ${bridge_interface}: setpromisc 1
		ngctl msg $tap: setautosrc 0
	fi
    echo -n " fw_tap" >&2
    ;;

stop)
	ifconfig $tap down
	$IF_CONFIG_DOWN
	killall fw_tap
	if [ X$bridged = XYES ]; then
		ngctl shutdown bridge_$tap:
		ngctl msg ${bridge_interface}: setautosrc 1
		ngctl msg ${bridge_interface}: setpromisc 0
	fi
    ;;

*)
    echo "usage: `basename $0` {start|stop}" >&2
    exit 64
    ;;
esac
